Index: uspace/app/sbi/src/builtin/bi_task.c
===================================================================
--- uspace/app/sbi/src/builtin/bi_task.c	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
+++ uspace/app/sbi/src/builtin/bi_task.c	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
@@ -0,0 +1,122 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file Task builtin binding. */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <assert.h>
+#include "../builtin.h"
+#include "../list.h"
+#include "../mytypes.h"
+#include "../os/os.h"
+#include "../run.h"
+#include "../strtab.h"
+
+#include "bi_task.h"
+
+static void bi_task_exec(run_t *run);
+
+/** Declare task builtin.
+ *
+ * @param bi	Builtin object
+ */
+void bi_task_declare(builtin_t *bi)
+{
+	builtin_code_snippet(bi,
+		"class Task is\n"
+			"fun Exec(args : string[], packed), static, builtin;\n"
+		"end\n");
+}
+
+/** Bind builtin functions.
+ *
+ * @param bi	Builtin object
+ */
+void bi_task_bind(builtin_t *bi)
+{
+	builtin_fun_bind(bi, "Task", "Exec", bi_task_exec);
+}
+
+/** Start an executable and wait for it to finish.
+ *
+ * @param run	Runner object
+ */
+static void bi_task_exec(run_t *run)
+{
+	rdata_var_t *args;
+	rdata_var_t *var;
+	rdata_array_t *array;
+	rdata_var_t *arg;
+	int idx, dim;
+	const char **cmd;
+
+#ifdef DEBUG_RUN_TRACE
+	printf("Called Task.Exec()\n");
+#endif
+	args = run_local_vars_lookup(run, strtab_get_sid("args"));
+
+	assert(args);
+	assert(args->vc == vc_ref);
+
+	var = args->u.ref_v->vref;
+	assert(var->vc == vc_array);
+
+	array = var->u.array_v;
+	assert(array->rank == 1);
+	dim = array->extent[0];
+
+	if (dim == 0) {
+		printf("Error: Builtin.Exec() expects at least one argument.\n");
+		exit(1);
+	}
+
+	cmd = calloc(dim + 1, sizeof(char *));
+	if (cmd == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	for (idx = 0; idx < dim; ++idx) {
+		arg = array->element[idx];
+		if (arg->vc != vc_string) {
+			printf("Error: Argument to Builtin.Exec() must be "
+			    "string (found %d).\n", arg->vc);
+			exit(1);
+		}
+
+		cmd[idx] = arg->u.string_v->value;
+	}
+
+	cmd[dim] = '\0';
+
+	if (os_exec((char * const *)cmd) != EOK) {
+		printf("Error: Exec failed.\n");
+		exit(1);
+	}
+}
Index: uspace/app/sbi/src/builtin/bi_task.h
===================================================================
--- uspace/app/sbi/src/builtin/bi_task.h	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
+++ uspace/app/sbi/src/builtin/bi_task.h	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
@@ -0,0 +1,37 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef BI_TASK_H_
+#define BI_TASK_H_
+
+#include "../mytypes.h"
+
+void bi_task_declare(builtin_t *bi);
+void bi_task_bind(builtin_t *bi);
+
+#endif
Index: uspace/app/sbi/src/imode.c
===================================================================
--- uspace/app/sbi/src/imode.c	(revision 5716e9afd07b8c8ac4e5fb6977a879035c2ffe10)
+++ uspace/app/sbi/src/imode.c	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -178,4 +178,17 @@
 			/* Convert expression result to value item. */
 			run_cvt_value_item(&run, rexpr, &rexpr_vi);
+			rdata_item_destroy(rexpr);
+
+			/* Check for unhandled exceptions. */
+			run_exc_check_unhandled(&run);
+		} else {
+			rexpr_vi = NULL;
+		}
+
+		/*
+		 * rexpr_vi can be NULL if either repxr was null or
+		 * if the conversion to value item raised an exception.
+		 */
+		if (rexpr_vi != NULL) {
 			assert(rexpr_vi->ic == ic_value);
 
@@ -184,6 +197,10 @@
 			rdata_value_print(rexpr_vi->u.value);
 			printf("\n");
+
+			rdata_item_destroy(rexpr_vi);
 		}
 	}
+
+	run_proc_ar_destroy(&run, proc_ar);
 
 	/* Remove block visit record from the stack, */
Index: uspace/app/sbi/src/intmap.c
===================================================================
--- uspace/app/sbi/src/intmap.c	(revision 5716e9afd07b8c8ac4e5fb6977a879035c2ffe10)
+++ uspace/app/sbi/src/intmap.c	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
@@ -50,4 +50,15 @@
 }
 
+/** Deinitialize map.
+ *
+ * The map must be already empty.
+ *
+ * @param intmap	Map to initialize.
+ */
+void intmap_fini(intmap_t *intmap)
+{
+	list_fini(&intmap->elem);
+}
+
 /** Set value corresponding to a key.
  *
@@ -56,7 +67,7 @@
  * is removed from the map.
  *
- * @param intmap	Map.
- * @param key		Key (integer).
- * @param value		Value (must be a pointer) or @c NULL.
+ * @param intmap	Map
+ * @param key		Key (integer)
+ * @param value		Value (must be a pointer) or @c NULL
  */
 void intmap_set(intmap_t *intmap, int key, void *value)
@@ -75,6 +86,5 @@
 				/* Remove map element. */
 				list_remove(&intmap->elem, node);
-				node->data = NULL;
-				free(node);
+				free(elem);
 			}
 			return;
@@ -98,6 +108,6 @@
 /** Get value corresponding to a key.
  *
- * @param intmap	Map.
- * @param key		Key for which to retrieve mapping.
+ * @param intmap	Map
+ * @param key		Key for which to retrieve mapping
  *
  * @return		Value correspoding to @a key or @c NULL if no mapping
@@ -121,2 +131,45 @@
 	return NULL;
 }
+
+/** Get first element in the map.
+ *
+ * For iterating over the map, this returns the first element (in no
+ * particular order).
+ *
+ * @param intmap	Map
+ * @return		Map element or NULL if the map is empty
+ */
+map_elem_t *intmap_first(intmap_t *intmap)
+{
+	list_node_t *node;
+
+	node = list_first(&intmap->elem);
+	if (node == NULL)
+		return NULL;
+
+	return list_node_data(node, map_elem_t *);
+}
+
+/** Get element key.
+ *
+ * Giver a map element, return the key.
+ *
+ * @param elem		Map element
+ * @return		Key
+ */
+int intmap_elem_get_key(map_elem_t *elem)
+{
+	return elem->key;
+}
+
+/** Get element value.
+ *
+ * Giver a map element, return the value.
+ *
+ * @param elem		Map element
+ * @return		Value
+ */
+void *intmap_elem_get_value(map_elem_t *elem)
+{
+	return elem->value;
+}
Index: uspace/app/sbi/src/intmap.h
===================================================================
--- uspace/app/sbi/src/intmap.h	(revision 5716e9afd07b8c8ac4e5fb6977a879035c2ffe10)
+++ uspace/app/sbi/src/intmap.h	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
@@ -33,6 +33,10 @@
 
 void intmap_init(intmap_t *intmap);
+void intmap_fini(intmap_t *intmap);
 void intmap_set(intmap_t *intmap, int key, void *data);
 void *intmap_get(intmap_t *intmap, int key);
+map_elem_t *intmap_first(intmap_t *intmap);
+int intmap_elem_get_key(map_elem_t *elem);
+void *intmap_elem_get_value(map_elem_t *elem);
 
 #endif
Index: uspace/app/sbi/src/lex.c
===================================================================
--- uspace/app/sbi/src/lex.c	(revision 5716e9afd07b8c8ac4e5fb6977a879035c2ffe10)
+++ uspace/app/sbi/src/lex.c	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -45,4 +45,9 @@
 #define TAB_WIDTH 8
 
+typedef enum {
+	cs_chr,
+	cs_str
+} chr_str_t;
+
 static void lex_touch(lex_t *lex);
 static bool_t lex_read_try(lex_t *lex);
@@ -57,4 +62,5 @@
 static void lex_number(lex_t *lex);
 static void lex_string(lex_t *lex);
+static void lex_char_string_core(lex_t *lex, chr_str_t cs);
 static int digit_value(char c);
 
@@ -117,4 +123,5 @@
 	{ lc_string,	"string" },
 	{ lc_struct,	"struct" },
+	{ lc_switch,	"switch" },
 	{ lc_then,	"then" },
 	{ lc_this,	"this" },
@@ -122,4 +129,5 @@
 	{ lc_var,	"var" },
 	{ lc_with,	"with" },
+	{ lc_when,	"when" },
 	{ lc_while,	"while" },
 	{ lc_yield,	"yield" },
@@ -535,30 +543,9 @@
 static void lex_char(lex_t *lex)
 {
-	char *bp;
-	int idx;
 	size_t len;
 	int char_val;
 
-	bp = lex->ibp + 1;
-	idx = 0;
-
-	while (bp[idx] != '\'') {
-		if (idx >= SLBUF_SIZE) {
-			printf("Error: Character literal too long.\n");
-			exit(1);
-		}
-
-		if (bp[idx] == '\0') {
-			printf("Error: Unterminated character literal.\n");
-			exit(1);
-		}
-
-		strlit_buf[idx] = bp[idx];
-		++idx;
-	}
-
-	lex->ibp = bp + idx + 1;
-
-	strlit_buf[idx] = '\0';
+	lex_char_string_core(lex, cs_chr);
+
 	len = os_str_length(strlit_buf);
 	if (len != 1) {
@@ -620,31 +607,84 @@
 static void lex_string(lex_t *lex)
 {
-	char *bp;
-	int idx;
-
-	bp = lex->ibp + 1;
-	idx = 0;
-
-	while (bp[idx] != '"') {
-		if (idx >= SLBUF_SIZE) {
-			printf("Error: String literal too long.\n");
-			exit(1);
-		}
-
-		if (bp[idx] == '\0') {
-			printf("Error: Unterminated string literal.\n");
-			exit(1);
-		}
-
-		strlit_buf[idx] = bp[idx];
-		++idx;
-	}
-
-	lex->ibp = bp + idx + 1;
-
-	strlit_buf[idx] = '\0';
+	lex_char_string_core(lex, cs_str);
 
 	lex->current.lclass = lc_lit_string;
 	lex->current.u.lit_string.value = os_str_dup(strlit_buf);
+}
+
+static void lex_char_string_core(lex_t *lex, chr_str_t cs)
+{
+	char *bp;
+	int sidx, didx;
+	char term;
+	const char *descr, *cap_descr;
+	char spchar;
+
+	/* Make compiler happy */
+	term = '\0';
+	descr = NULL;
+	cap_descr = NULL;
+
+	switch (cs) {
+	case cs_chr:
+		term = '\'';
+		descr = "character";
+		cap_descr = "Character";
+		break;
+	case cs_str:
+		term = '"';
+		descr = "string";
+		cap_descr = "String";
+		break;
+	}
+
+	bp = lex->ibp + 1;
+	sidx = didx = 0;
+
+	while (bp[sidx] != term) {
+		if (didx >= SLBUF_SIZE) {
+			printf("Error: %s literal too long.\n", cap_descr);
+			exit(1);
+		}
+
+		if (bp[sidx] == '\0') {
+			printf("Error: Unterminated %s literal.\n", descr);
+			exit(1);
+		}
+
+		if (bp[sidx] == '\\') {
+			switch (bp[sidx + 1]) {
+			case '\\':
+				spchar = '\\';
+				break;
+			case '\'':
+				spchar = '\'';
+				break;
+			case '"':
+				spchar = '"';
+				break;
+			case 'n':
+				spchar = '\n';
+				break;
+			case 't':
+				spchar = '\t';
+				break;
+			default:
+				printf("Error: Unknown character escape sequence.\n");
+				exit(1);
+			}
+
+			strlit_buf[didx] = spchar;
+			++didx;
+			sidx += 2;
+		} else {
+			strlit_buf[didx] = bp[sidx];
+			++sidx; ++didx;
+		}
+	}
+
+	lex->ibp = bp + sidx + 1;
+
+	strlit_buf[didx] = '\0';
 }
 
Index: uspace/app/sbi/src/lex_t.h
===================================================================
--- uspace/app/sbi/src/lex_t.h	(revision 5716e9afd07b8c8ac4e5fb6977a879035c2ffe10)
+++ uspace/app/sbi/src/lex_t.h	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -85,4 +85,5 @@
 	lc_string,
 	lc_struct,
+	lc_switch,
 	lc_then,
 	lc_this,
@@ -90,4 +91,5 @@
 	lc_var,
 	lc_with,
+	lc_when,
 	lc_while,
 	lc_yield,
Index: uspace/app/sbi/src/list.c
===================================================================
--- uspace/app/sbi/src/list.c	(revision 5716e9afd07b8c8ac4e5fb6977a879035c2ffe10)
+++ uspace/app/sbi/src/list.c	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -57,4 +57,16 @@
 }
 
+/** Deinitialize list.
+ *
+ * @param list	List to deinitialize.
+ */
+void list_fini(list_t *list)
+{
+	assert(list_is_empty(list));
+
+	list->head.prev = NULL;
+	list->head.next = NULL;
+}
+
 /** Append data to list.
  *
Index: uspace/app/sbi/src/list.h
===================================================================
--- uspace/app/sbi/src/list.h	(revision 5716e9afd07b8c8ac4e5fb6977a879035c2ffe10)
+++ uspace/app/sbi/src/list.h	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -34,4 +34,5 @@
 
 void list_init(list_t *list);
+void list_fini(list_t *list);
 void list_append(list_t *list, void *data);
 void list_prepend(list_t *list, void *data);
Index: uspace/app/sbi/src/parse.c
===================================================================
--- uspace/app/sbi/src/parse.c	(revision 5716e9afd07b8c8ac4e5fb6977a879035c2ffe10)
+++ uspace/app/sbi/src/parse.c	(revision 76b5a95cdf127e6bca3c36046fa6af8e0e443f48)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -82,4 +82,5 @@
 static stree_vdecl_t *parse_vdecl(parse_t *parse);
 static stree_if_t *parse_if(parse_t *parse);
+static stree_switch_t *parse_switch(parse_t *parse);
 static stree_while_t *parse_while(parse_t *parse);
 static stree_for_t *parse_for(parse_t *parse);
@@ -667,5 +668,4 @@
 	stree_prop_t *prop;
 	stree_symbol_t *symbol;
-	bool_t body_expected;
 
 	stree_ident_t *ident;
@@ -720,6 +720,4 @@
 	/* Parse attributes. */
 	parse_symbol_attrs(parse, symbol);
-
-	body_expected = (outer_csi->cc != csi_interface);
 
 	lmatch(parse, lc_is);
@@ -1070,4 +1068,5 @@
 	stree_vdecl_t *vdecl_s;
 	stree_if_t *if_s;
+	stree_switch_t *switch_s;
 	stree_while_t *while_s;
 	stree_for_t *for_s;
@@ -1092,4 +1091,9 @@
 		stat->u.if_s = if_s;
 		break;
+	case lc_switch:
+		switch_s = parse_switch(parse);
+		stat = stree_stat_new(st_switch);
+		stat->u.switch_s = switch_s;
+		break;
 	case lc_while:
 		while_s = parse_while(parse);
@@ -1214,4 +1218,58 @@
 	lmatch(parse, lc_end);
 	return if_s;
+}
+
+/** Parse @c switch statement.
+ *
+ * @param parse		Parser object.
+ * @return		New syntax tree node.
+ */
+static stree_switch_t *parse_switch(parse_t *parse)
+{
+	stree_switch_t *switch_s;
+	stree_when_t *when_c;
+	stree_expr_t *expr;
+
+#ifdef DEBUG_PARSE_TRACE
+	printf("Parse 'switch' statement.\n");
+#endif
+	lmatch(parse, lc_switch);
+
+	switch_s = stree_switch_new();
+	list_init(&switch_s->when_clauses);
+
+	switch_s->expr = parse_expr(parse);
+	lmatch(parse, lc_is);
+
+	/* Parse @c when clauses. */
+	while (lcur_lc(parse) == lc_when) {
+		lskip(parse);
+		when_c = stree_when_new();
+		list_init(&when_c->exprs);
+		while (b_true) {
+			expr = parse_expr(parse);
+			list_append(&when_c->exprs, expr);
+			if (lcur_lc(parse) != lc_comma)
+				break;
+			lskip(parse);
+		}
+
+		lmatch(parse, lc_do);
+		when_c->block = parse_block(parse);
+
+		list_append(&switch_s->when_clauses, when_c);
+	}
+
+	/* Parse @c else clause. */
+	if (lcur_lc(parse) == lc_else) {
+		lskip(parse);
+		lmatch(parse, lc_do);
+		switch_s->else_block = parse_block(parse);
+	} else {
+		switch_s->else_block = NULL;
+	}
+
+	lmatch(parse, lc_end);
+	return switch_s;
 }
 
@@ -1654,4 +1712,5 @@
 	case lc_except:
 	case lc_finally:
+	case lc_when:
 		return b_true;
 	default:
